package ch.bouquet.security;

import java.security.InvalidKeyException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

public class Encryptor
{

  private static Key senderKey = new SecretKeySpec( "01234567".getBytes(), "DES" );

  private static Key receiverKey = new SecretKeySpec( "01234467".getBytes(), "DES" );

  // 01234567 / 01234467

  private static String senderMessage = "This is the message";

  private static String receiverMessage = "This is the message";

  public static void main( String[] args )
  {
    try
    {

      System.out.println( senderKey.equals( receiverKey ) );

      // ---------------------------------
      // Alice
      // ---------------------------------

      // Create hash
      MessageDigest senderMessageDigest = MessageDigest.getInstance( "SHA" );
      byte[] senderHash = senderMessageDigest.digest( senderMessage.getBytes() );

      // Encrypt hash
      Cipher senderCipher = Cipher.getInstance( "DES" );
      senderCipher.init( Cipher.ENCRYPT_MODE, senderKey );
      byte[] encryptedSenderHash = senderCipher.doFinal( senderHash );

      // encryptedSenderHash[3] = 7;
      
      // ---------------------------------
      // Bob
      // ---------------------------------

      // Create hash
      MessageDigest receiverMessageDigest = MessageDigest.getInstance( "SHA" );
      byte[] receiverHash = receiverMessageDigest.digest( receiverMessage.getBytes() );

      // Decrypt the encrypted sender hash
      Cipher receiverCipher = Cipher.getInstance( "DES" );
      receiverCipher.init( Cipher.DECRYPT_MODE, receiverKey );
      byte[] decriptedSenderHash = receiverCipher.doFinal( encryptedSenderHash );

      printByteArray( receiverHash );
      printByteArray( decriptedSenderHash );

      // Compare both hashes
      System.out.println( new String( receiverHash ).equals( new String( decriptedSenderHash ) ) );

    }
    catch ( NoSuchAlgorithmException e )
    {
      e.printStackTrace();
    }
    catch ( NoSuchPaddingException e )
    {
      e.printStackTrace();
    }
    catch ( InvalidKeyException e )
    {
      e.printStackTrace();
    }
    catch ( IllegalBlockSizeException e )
    {
      e.printStackTrace();
    }
    catch ( BadPaddingException e )
    {
      e.printStackTrace();
    }

  }

  private static void printByteArray( byte[] bytes )
  {
    for ( int i = 0; i < bytes.length; i++ )
    {
      System.out.print( bytes[i] + " - " );
    }
    System.out.println();
  }
}
